'
' Programm gibt ber die serielle Schnittstelle eingehende Zeichen akustisch als Mosecode aus und
' sendet ber die Paddles eingegebenen Morsecode auf die serielle Schnittstelle
'
' Die Tonhhe ist fest eingestellt.
'
' Pin PB3 wird als Timer2-Ausgang OC2a verwendet, Ton wird durch Umschalten des
' Pins als Eingang / Ausgang ein- und ausgeschaltet
'
' Das Paddle fr die Eingabe der Morsezeichen liegt an PD2 (Punktkontakt) und PD3 (Strichkontakt)
'
' Version 2a vermindert die Anforderungen an die Gebeprzision; auch bei kleinen Pausen zwischen Punkt und Strich
' wird auf ein gemeinsames Zeichen erkannt

' Version 3 sendet bei Pause > 5 Punkte genau ein Leerzeichen auf des Terminal
'
'- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
'
' Grundeinstelllungen:
$regfile = "m88def.dat"
$crystal = 8000000                                          ' Quarzoszillator 3,6864 MHz
'$hwstack = 40                                               ' 32 Byte wegen Interrupt + 8 bBytes fr max.4 Unterprogramme
'$swstack = 0
'$framesize = 0
$baud = 9600

'- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -

'Variablen und Konstanten dimensionieren:
'

Dim Recbyte As Byte
Dim I As Byte                                               'Fr temporren Gebrauch als Schleifenzhler
Dim J As Byte                                               '              ''
Dim K As Byte                                               '              ''
Dim Z As Byte                                               ' Z=1, wenn bereits ein Leerzeichen gesendet wurde
Dim M As Byte                                               ' Index des aktuellen Morsebuchstabens in unserer Tabelle
Dim L As Byte                                               ' fr niederwertigstes Bit beim bitweisen Erzeugen des Morsezeichens

Dim D As Byte                                               ' Morsebyte in der Decodierroutine
Dim P As Byte                                               ' Punktspeicher-Bit der Decodierroutine
Dim E As Byte                                               ' resultierendes ACCII-Byte der Decodierroutine

Dim Tonhoehe As Byte

Dim Punktlaenge As Word                                     ' Punktlnge in "Empfangsrichtung"
Dim Punktachtel As Word
Dim Strichlaenge As Word                                    ' Strichlnge
Dim Wortpause As Word                                       ' Lnge Wortpause
'
'
Buzzer Alias Ddrb.3
Punktkontakt Alias Pind.3
Strichkontakt Alias Pind.2

'- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
'Initialisierung des Programms:
'
Config Adc = Single , Prescaler = 16 , Reference = Avcc
Start Adc
'

 ' Morseton mit Timer2 erzeugen:
'
' Timer2 zhlt das Register TCNT2 hoch. Es wird mit Register OCR2 verglichen.
' Wenn TCNT2 = OCR2, wird Output OC2A/PB3 umgeschaltet (getoggled)
' Timer2 erzeugt so Dauerton; er wird jedoch nur an den Ausgangspin durchgeschaltet,
' wenn das Datenrichtungs- Register DDRB.3 = 1 ist. Bei 0 wird der Ton unterdrckt.
'
Config Timer2 = Timer , Compare A = Toggle , Prescale = 64 , Clear Timer = 1


Acsr.acd = 0                                                ' Analog-Komparator ausschalten, spart etwas Strom
Portb = &B11111111                                          'floatende Eingnge vermeiden
Portc = &B01111111                                          ' PC.7 wird fr ADC genutzt
Portd = &B11111111

Ddrb.2 = 0                                                  ' der Bootloader hinterlt PB.2 als Ausgang

Config Serialin = Buffered , Size = 250                     ' Buffer fr serielle Schnittstelle einrichten
Enable Interrupts



'- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -



Main:


 Buzzer = 0

 Do

    Tonhoehe = 128
    Ocr2a = Tonhoehe
    Gosub Potis                                             ' Geschwindigkeit ermitteln
    Gosub Zeichenlesen

    If Punktkontakt = 0 Or Strichkontakt = 0 Then           ' Punkt - oder Strichkontakt gedrckt
       Gosub Decodekeyer
       Print Chr(e);                                        ' aufs Terminal senden
       Z = 0                                                ' Leerzeichenflag zurcksetzen
       If D <> 45 Then                                      ' an ein Return darf kein Leerzeichen angehngt werden
          Gosub Leerzeichenpruefg
       End If
    End If

 Loop

Zeichenlesen:

    If Ischarwaiting() = 1 Then                             ' wenn was da ist
       Recbyte = Waitkey()                                  ' einlesen
       Print Chr(recbyte);                                  ' auf Terminal Echo ausgeben
       If Recbyte = &H0D Then                               ' Wenn Carriage Return empfangen wurde,
         Printbin &H0A                                      ' dann Linefeed anhngen
       End If
       M = Lookup(recbyte , Morsetabelle)                   ' Morsezeichen aus Tabelle holen
       Gosub Morse
    End If                                                  ' Morsezeichen erzeugen

Return


 Potis:
       Punktlaenge = Getadc(7)                              ' Punktlnge durch Poti einstellbar;
       Punktlaenge = Punktlaenge + 512                      ' fr sinnvollen Einstellbereich
       Punktlaenge = Punktlaenge / 16                       ' aus der Punktlnge ergibt sich die Morsegeschwindigkeit
       Strichlaenge = Punktlaenge * 3                       ' Strichlnge: 3 Punktlngen
       Wortpause = Punktlaenge * 5                          ' Pause zwischen Worten: 5 Punktlngen

  Return


   ' Morsezeichenerzeugung:

  Morse:

      If M = 0 Then                                         ' Sonderfall: Leerzeichen;
         Waitms Wortpause
         Goto Zeichenende
      End If

      For I = 1 To 8
        If M = 1 Then                                       ' Das Byte hat nur noch den Wert 1; Zeichenende!
          Goto Zeichenende
        End If
        L = M And &B00000001                                ' niederwertigstes Bit lesen
           Portb.2 = 1
           Buzzer = 1
        If L = 1 Then
           Waitms Strichlaenge                              ' ist das Bit 1 -> dah
          Else
           Waitms Punktlaenge                               ' ist das Bit 0 -> dit
        End If
          Portb.2 = 0
         Buzzer = 0
        Waitms Punktlaenge                                  ' Pause innerhalb des Morsezeichens
        Shift M , Right , 1                                 ' Bits um eine Stelle nach rechts shiften
      Next I
     Zeichenende:
     Waitms Strichlaenge                                    ' Pause zwischen Morsezeichen

  Return





Decodekeyer:                                                ' Prinzip: eine 1 wird in der Variablen "K" von links nach rechts geschoben.
                                                            ' nur wenn Strich gedrckt wurde, wird die 1 in die Variable D bernommen
  Tonhoehe = 160
  Ocr2a = Tonhoehe
  D = 0
  K = 1
  Do

      If Punktkontakt = 0 Then                              ' Punktkontakt gedrckt
        Buzzer = 1                                          ' Ton an
        Waitms Punktlaenge
        Buzzer = 0                                          ' Ton aus
        Waitms Punktlaenge
        Shift K , Left                                      ' Byteinhalt wandert 1 Stelle nach links, von rechts wird eine "0" eingeschoben

      End If

  Mark:

      If Strichkontakt = 0 Then                             ' Strichkontakt gedrckt
        Buzzer = 1                                          '  Ton an
        Waitms Strichlaenge
         D = D + K                                          ' die 1 fr den Strich wird in die Variable "D" bernommen
        Shift K , Left                                      ' Byteinhalt wandert 1 Stelle nach rechts, von links eine "0" eingeschoben
        If Punktkontakt = 0 Then
           P = 1                                            ' wenn Punktkontakt ebenfalls gedrckt
        End If                                              ' Punktspeicher setzen

        Buzzer = 0                                          ' Ton aus
        Waitms Punktlaenge

        If P = 1 Then                                       ' Punktspeicher prfen
          Buzzer = 1                                        ' Ton an
          Waitms Punktlaenge
          Buzzer = 0                                        ' Ton aus
          Waitms Punktlaenge
          Shift K , Left                                    ' Byteinhalt wandert 1 Stelle nach links, rechts wird 0 eingeschoben
          P = 0                                             ' Punktspeicher zurcksetzen
          Goto Mark                                         ' Prfen, ob Strichkontakt bereits wieder gedrckt
        End If

      End If


      J = 0
      Do                                                    ' wir warten max. halbe Punktlnge, um unexakte Gebeweise abzufangen
         If Punktkontakt = 0 Or Strichkontakt = 0 Then      ' vorzeitiger Ausstieg, wenn Punktkontakt oder Strichkontakt gedrckt
             Exit Do
          End If
          Waitms Punktachtel
          J = J + 1
      Loop Until J = 4                                      ' Abbruch bei halber Punktlnge

  Loop Until Punktkontakt = 1 And Strichkontakt = 1         ' kein Kontakt mehr gedrckt; Morsezeichen fertig

      D = D + K                                             ' eine 1 wird als Endbit angehngt


  E = Lookdown(d , Morsetabelle , 128)                      ' inverse Lookup in der Tabelle, um den zugehrigen Ascii- Wert zu ermitteln
  E = E - 1                                                 ' Data- Elemente werden ab 1 gezhlt, Ascii- Tabelle beginnt bei Null
  If E > 64 Then                                            ' "lookdown" findet stets die Grossbuchstaben.
    E = E + 32                                              ' Wir wollen Kleinbuchstaben (wichtig fr Linux)
  End If

Return




Leerzeichenpruefg:

  I = 0

  If Z = 0 Then                                             ' noch kein Leerzeichen auf Terminal gesendet

    Do

      If Punktkontakt = 0 Or Strichkontakt = 0 Then         ' Abruch, wenn Punkt- oder Strichkontakt gedrckt
         Exit Do
      End If
      Waitms Punktachtel
      I = I + 1
    Loop Until I = 48                                       ' 48 Achtel =  6 Punktlngen

    If I = 48 Then
       Print " ";                                           ' Leerzecihen auf Terminal
       Z = 1                                                ' Flag, dass Leerzeichen gesendet wurde
    End If

  End If
Return





'- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -


Morsetabelle:

'Ascii 0 - 32 ; hier wird nur Linefeed in <kn> umgesetzt

Data 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , &B00101101 , 0 , , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0
Data 0 , 0 , 0 , 0 , 0 , 0 , 0


' Ascii 32 - 47   ->   _!"#$%&'()*+,-./
Data 0 , 0 , &B01010010 , 0 , 0 , 0 , 0 , 0 , &B00101101 , &B01101101 , 0 , &B00101010 , &B01110011 , &B01100001
Data &B01101010 , &B00101001

'Ascii 48 - 57  ->  0123456789
Data &B00111111 , &B00111110 , &B00111100 , &B00111000 , &B00110000 , &B00100000 , &B00100001 , &B00100011 , &B00100111 , &B00101111

'Ascii 58 - 64  ->  :;<=>?@
Data &B01000111 , &B01110011 , &B00101101 , &B00110001 , &B01101101 , &B01001100 , 0

'Ascii 65 -  90        ABCDEFGHIJKLMNOPQRSTUVWXYZ
Data &B00000110 , &B00010001 , &B00010101 , &B00001001 , &B00000010 , &B00010100 , &B00001011 , &B00010000 , &B00000100
Data &B00011110 , &B00001101 , &B00010010 , &B00000111 , &B00000101 , &B00001111 , &B00010110 , &B00011011 , &B00001010
Data &B00001000 , &B00000011 , &B00001100 , &B00011000 , &B00001110 , &B00011001 , &B00011101 , &B00010011

'Ascii 91 - 96  ->  Muell

Data 0 , 0 , 0 , 0 , 0 , 0

' Ascii 97 - 122  abcdrfghijklmnopqrstuvwxyz

Data &B00000110 , &B00010001 , &B00010101 , &B00001001 , &B00000010 , &B00010100 , &B00001011 , &B00010000 , &B00000100
Data &B00011110 , &B00001101 , &B00010010 , &B00000111 , &B00000101 , &B00001111 , &B00010110 , &B00011011 , &B00001010
Data &B00001000 , &B00000011 , &B00001100 , &B00011000 , &B00001110 , &B00011001 , &B00011101 , &B00010011

'Ascii 123 - 127  -> Muell